import { world, TicksPerSecond, Block, Player, system } from "@minecraft/server";

const dinosaurRibs = {
  "id": "dominion:dinosaur_ribsdomi",
  "effect": "hunger",
  "effectDuration": 30
};

const rawLocust = {
  "id": "dominion:raw_locustdomi",
  "effect": "hunger",
  "effectDuration": 20
};

const dinoDrumstick = {
  "id": "dominion:dino_drumstickdomi",
  "effect": "hunger",
  "effectDuration": 30
};

world.afterEvents.itemCompleteUse.subscribe(e => {
  const { itemStack: item, source: player } = e;

  switch (item.typeId) {
    case dinosaurRibs.id:
      const dice = Math.round(Math.random());

      if (dice) player.addEffect(dinosaurRibs.effect, TicksPerSecond * dinosaurRibs.effectDuration);
      break;

    case rawLocust.id:
      const dice2 = Math.round(Math.random());

      if (dice2) player.addEffect(rawLocust.effect, TicksPerSecond * rawLocust.effectDuration);
      break;

    case dinoDrumstick.id:
      const dice3 = Math.round(Math.random());

      if (dice3) player.addEffect(dinoDrumstick.effect, TicksPerSecond * dinoDrumstick.effectDuration);
      break;
  }
});

system.runInterval(() => {
  const Players = world.getAllPlayers().filter(v => v.getComponent("minecraft:rideable").getRiders().length && v.isSneaking);

  Players.forEach(player => {
    const variableOne = "dominion:dimorphodon_d"
    const variableTwo = "dominion:compsognathus_d"
    const variableThree = "dominion:microceratus_d"
    player.getComponent("minecraft:rideable").ejectRiders();
    const rideable = player.getComponent("minecraft:rideable");
    const dimorphodon = rideable.getRiders()
      .filter(r => r.typeId === variableOne);
    const compsognathus = rideable.getRiders()
      .filter(r => r.typeId === variableTwo);
    const microceratus = rideable.getRiders()
      .filter(r => r.typeId === variableThree);

    dimorphodon.forEach(dimorphodon => {
      rideable.ejectRider(dimorphodon);
      dimorphodon.applyImpulse({ x: 0.3, y: 0.3, z: -0.3 })
    });
    compsognathus.forEach(compsognathus => {
      rideable.ejectRider(compsognathus);
      compsognathus.applyImpulse({ x: 0.3, y: 0.3, z: -0.3 })
    });
    microceratus.forEach(microceratus => {
      rideable.ejectRider(microceratus);
      microceratus.applyImpulse({ x: 0.3, y: 0.3, z: -0.3 })
    });
  })
}, 0);
